<?php
/**
 * The template part for displaying page content
 *
 * @package BoomBox_Theme
 * @since   1.0.0
 * @version 2.0.0
 */

// Prevent direct script access.
if ( ! defined( 'ABSPATH' ) ) {
	die( 'No direct script access allowed' );
}
do_action( 'boombox/before_page_content' );
add_filter( 'post_class', 'boombox_remove_editor_article_classes', 10, 3 );

$featured_image_size = 'boombox_image768';
$content = boombox_get_the_content();
// temporary solution
if( trim( strip_tags( $content ) ) ) { ?>
<article id="post-<?php the_ID(); ?>" <?php post_class( 'bb-card-item' ); ?>>
	<div class="entry-content">
		<div class="section-box">
			<?php
				$post_thumbnail_html = boombox_get_post_thumbnail( null, $featured_image_size );
				if( $post_thumbnail_html ) { ?>
					<div class="post-thumbnail">
						<?php echo $post_thumbnail_html;
						echo boombox_get_post_thumbnail_caption(); ?>
					</div>
					<?php
				}
				
				echo $content;
				wp_link_pages( array( 'layout' => 'page_xy', 'class' => 'pg-lg' ) ); ?>
		</div>
	</div>
</article>
<?php }

do_action( 'boombox/after_page_content' );